# 批量推送布署徐书法项目

## 1 pull-ca

> 批量下载书法练习轨迹

```sh
#!/bin/bash
#sh pull-ca.sh
copyPull(){
	cd $data_dir
	echo $PWD 'begin...'
	git pull
	echo '.........end.........'
}

#gitlab 0
data_dir=/e/Project/gitlab/calligraphy
copyPull

#agit 1
data_dir=/e/Project/gitlab/agit/calligraphy
copyPull

#bitbucket 2
data_dir=/e/Project/gitlab/bitbucket/calligraphy
copyPull

#codeberg 3
data_dir=/e/Project/gitlab/codeberg/calligraphy
copyPull

#coding 4
data_dir=/e/Project/gitlab/coding/calligraphy
copyPull

#gitcode 5
data_dir=/e/Project/gitlab/gitcode/calligraphy
copyPull

#gitea 6
data_dir=/e/Project/gitlab/gitea/calligraphy
copyPull

#sourceforge 7  need password

#gitee 8
data_dir=/e/Project/gitee/calligraphy
copyPull

#github 9
data_dir=/e/Project/github/calligraphy
copyPull




# gitlab ：MyNotes  imgs
data_dir=/e/Project/gitlab/MyNotes
copyPull

data_dir=/e/Project/gitlab/imgs
copyPull

# coding ：MyNotes  imgs
data_dir=/e/Project/gitlab/coding/MyNotes
copyPull

data_dir=/e/Project/gitlab/coding/imgs
copyPull


# gitcode ：MyNotes  imgs
data_dir=/e/Project/gitlab/gitcode/MyNotes
copyPull

data_dir=/e/Project/gitlab/gitcode/imgs
copyPull


# github ：MyNotes  imgs
data_dir=/e/Project/github/MyNotes
copyPull

data_dir=/e/Project/github/imgs
copyPull


# gitee ：MyNotes
data_dir=/e/Project/gitee/MyNotes
copyPull


```


## 2 push-ca

> 批量推送书法练习轨迹

```sh
#!/bin/bash
#sh push-ca.sh
copyPush(){
	cp -r /e/Project/gitlab/calligraphy/*.md $data_dir
	cp -r /e/Project/gitlab/calligraphy/书法字帖 $data_dir
	cd $data_dir
	echo $PWD 'begin...'
	git add .
	git commit -m "fix"
	git push
	echo '.........end.........'
}

#agit 1
data_dir=/e/Project/gitlab/agit/calligraphy
copyPush

#bitbucket 2
data_dir=/e/Project/gitlab/bitbucket/calligraphy
copyPush

#codeberg 3
data_dir=/e/Project/gitlab/codeberg/calligraphy
copyPush

#coding 4
data_dir=/e/Project/gitlab/coding/calligraphy
copyPush

#gitcode 5
data_dir=/e/Project/gitlab/gitcode/calligraphy
copyPush

#gitea 6
data_dir=/e/Project/gitlab/gitea/calligraphy
copyPush

#sourceforge 7  need password

#gitee 8
data_dir=/e/Project/gitee/calligraphy
copyPush

#github 9
data_dir=/e/Project/github/calligraphy
copyPush



copyPushNote(){
	cp -r /e/Project/gitlab/MyNotes/* $data_dir
	cd $data_dir
	echo $PWD 'begin...'
	git add .
	git commit -m "fix"
	git push
	echo '.........end.........'
}


# coding ：MyNotes
data_dir=/e/Project/gitlab/coding/MyNotes
copyPushNote

# gitcode ：MyNotes
data_dir=/e/Project/gitlab/gitcode/MyNotes
copyPushNote

# github ：MyNotes
data_dir=/e/Project/github/MyNotes
copyPushNote

# gitee ：MyNotes
data_dir=/e/Project/gitee/MyNotes
copyPushNote

```


## 3 pull-blog

> 批量下载徐书法项目

```sh
#!/bin/bash
#sh pull-blog.sh
copyPull(){
	cd $data_dir
	echo $PWD 'begin...'
	git pull
	echo '.........end.........'
}

#docsify-blog
data_dir=/e/Project/github/docsify-blog
copyPull

#docsify-calligraphy
data_dir=/e/Project/github/docsify-calligraphy
copyPull

#mkdocs-blog
data_dir=/e/Project/gitlab/mkdocs-blog
copyPull

#mkdocs-calligraphy
data_dir=/e/Project/gitlab/mkdocs-calligraphy
copyPull


#gitbook-blog
data_dir=/e/Project/github/gitbook-blog
copyPull

#gitbook-calligraphy
data_dir=/e/Project/github/gitbook-calligraphy
copyPull

#vuepress-blog
data_dir=/e/Project/github/vuepress-blog
copyPull

#vuepress-calligraphy
data_dir=/e/Project/github/vuepress-calligraphy
copyPull


#reco-blog
data_dir=/e/Project/github/reco-blog
copyPull

#reco-calligraphy
data_dir=/e/Project/github/reco-calligraphy
copyPull


```


## 4 deploy-blog

> 批量布署徐书法项目

```sh
#!/bin/bash
#sh deploy-blog.sh


#cd /e/Project/github/vuepress-blog
#git pull


cd /e/Project/github/vuepress-calligraphy
# https://github.com/scott180/vuepress-calligraphy
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/github/vuepress-calligraphy/docs
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/vuepress-calligraphy/docs/练习
git add .
git commit -m "fix"
git push
rm -rf docs/.vuepress/dist/*
# npm run docs:dev
npm run deploy


cd /e/Project/github/docsify-blog
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/github/docsify-blog/docs/书法
cp -a /e/Project/github/vuepress-blog/docs/编程/* /e/Project/github/docsify-blog/docs/编程
cp -a /e/Project/github/vuepress-blog/docs/生活/* /e/Project/github/docsify-blog/docs/生活
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/docsify-blog/docs/书法/练习
git add .
git commit -m "fix"
git push
# cd docs && docsify serve


cd /e/Project/github/docsify-calligraphy
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/github/docsify-calligraphy/docs
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/docsify-calligraphy/docs/练习
git add .
git commit -m "fix"
git push
# cd docs && docsify serve



cd /e/Project/gitlab/mkdocs-blog
# https://gitlab.com/xuyq123/mkdocs-blog
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/gitlab/mkdocs-blog/docs/书法
cp -a /e/Project/github/vuepress-blog/docs/编程/* /e/Project/gitlab/mkdocs-blog/docs/编程
cp -a /e/Project/github/vuepress-blog/docs/生活/* /e/Project/gitlab/mkdocs-blog/docs/生活
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/gitlab/mkdocs-blog/docs/书法/练习
git add .
git commit -m "fix"
git push
# mkdocs serve


cd /e/Project/gitlab/mkdocs-calligraphy
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/gitlab/mkdocs-calligraphy/docs
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/gitlab/mkdocs-calligraphy/docs/练习
git add .
git commit -m "fix"
git push
# mkdocs serve



cd /e/Project/github/gitbook-blog
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/github/gitbook-blog/书法
cp -a /e/Project/github/vuepress-blog/docs/编程/* /e/Project/github/gitbook-blog/编程
cp -a /e/Project/github/vuepress-blog/docs/生活/* /e/Project/github/gitbook-blog/生活
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/gitbook-blog/书法/练习
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/gitbook-blog
rm -rf README.md && mv 关于我.md README.md
rm -rf docs
gitbook build
mv _book docs
git add .
git commit -m "fix"
git push
# gitbook serve


cd /e/Project/github/gitbook-calligraphy
#git pull
echo $PWD '...'
cp -a /e/Project/github/vuepress-blog/docs/书法/* /e/Project/github/gitbook-calligraphy
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/gitbook-calligraphy/练习
cp -a /e/Project/github/vuepress-blog/docs/关于我.md /e/Project/github/gitbook-blog
rm -rf docs
gitbook build
mv _book docs
git add .
git commit -m "fix"
git push
# gitbook serve

rm -rf /e/Project/github/gitbook-blog/关于我.md


#cd /e/Project/github/reco-blog          
#cd /e/Project/github/reco-calligraphy
# vuepress-theme-reco 每个文件需要配置分类、标签、创建时间
# https://github.com/scott180/reco-blog


```
